(function(){
  var ref$, map, filter, id, concatMap, each, fillIntervals, trendLine, rextend, fillIntervalsF, trendLineF, toString$ = {}.toString;
  ref$ = require('prelude-ls'), map = ref$.map, filter = ref$.filter, id = ref$.id, concatMap = ref$.concatMap, each = ref$.each;
  ref$ = require('./_utils'), fillIntervals = ref$.fillIntervals, trendLine = ref$.trendLine, rextend = ref$.rextend;
  fillIntervalsF = fillIntervals;
  trendLineF = trendLine;
  module.exports = function(arg$){
    var d3, nv;
    d3 = arg$.d3, nv = arg$.nv;
    return {
      options: {
        key: function(it){
          return it.key;
        },
        values: function(it){
          return it.values;
        },
        color: function(it){
          return it.color;
        },
        margin: {
          top: 20,
          right: 20,
          bottom: 50,
          left: 50
        },
        x: function(it){
          return it[0];
        },
        xAxis: {
          format: id,
          label: null,
          distance: 0
        },
        y: function(it){
          return it[1];
        },
        yAxis: {
          format: id,
          label: null,
          distance: 0
        },
        forceY: null,
        fillIntervals: false,
        trendLine: null
      },
      plotter: curry$(function(f, nvModel, g, view, rawSeries, options, continuation){
        var this$ = this;
        nv.addGraph(function(){
          var x, xAxis, y, yAxis, forceY, key, values, color, fillIntervals, trendLine, margin, refinedSeries, projectedSeries, seriesWithTrendline, ref$;
          x = options.x, xAxis = options.xAxis, y = options.y, yAxis = options.yAxis, forceY = options.forceY, key = options.key, values = options.values, color = options.color, fillIntervals = options.fillIntervals, trendLine = options.trendLine, margin = options.margin;
          refinedSeries = map(function(series){
            var ref$;
            return ref$ = import$({}, series), ref$.key = key(series), ref$.values = values(series), ref$.color = color(series), ref$;
          })(
          rawSeries);
          projectedSeries = f(refinedSeries, options);
          seriesWithTrendline = (function(){
            switch (false) {
            case 'Function' !== toString$.call(trendLine).slice(8, -1):
              return projectedSeries.concat(function(){
                return map(function(arg$){
                  var key, values, trend, ref$, name, sampleSize, color;
                  key = arg$.key, values = arg$.values, trend = arg$.trend;
                  ref$ = rextend({
                    name: key + " trend",
                    sampleSize: 2,
                    color: 'red'
                  }, trend), name = ref$.name, sampleSize = ref$.sampleSize, color = ref$.color;
                  return {
                    key: name,
                    values: trendLineF(values, sampleSize),
                    color: color
                  };
                })(
                filter(function(it){
                  return it.trend !== null;
                })(
                map(function(me){
                  var key;
                  key = me.key;
                  return import$({
                    trend: trendLine(key)
                  }, me);
                })(
                projectedSeries)));
              }());
            default:
              return projectedSeries;
            }
          }());
          this$.chart = (ref$ = this$.chart) != null
            ? ref$
            : nvModel(nv.models)();
          each(function(arg$){
            var getMethod, prop, method;
            getMethod = arg$[0], prop = arg$[1];
            method = getMethod(this$.chart);
            if (!!method) {
              return method(prop);
            }
          })(
          filter(function(it){
            return !!it[1];
          })(
          [
            [
              function(it){
                return it.margin;
              }, margin
            ], [
              function(it){
                return it.xAxis.tickFormat;
              }, xAxis.format
            ], [
              function(it){
                return it.xAxis.axisLabel;
              }, xAxis.label
            ], [
              function(it){
                return it.xAxis.axisLabelDistance;
              }, xAxis.distance
            ], [
              function(it){
                var ref$;
                return it != null ? (ref$ = it.yAxis) != null ? ref$.tickFormat : void 8 : void 8;
              }, yAxis.format
            ], [
              function(it){
                var ref$;
                return it != null ? (ref$ = it.yAxis) != null ? ref$.axisLabel : void 8 : void 8;
              }, yAxis.label
            ], [
              function(it){
                var ref$;
                return it != null ? (ref$ = it.yAxis) != null ? ref$.axisLabelDistance : void 8 : void 8;
              }, yAxis.distance
            ], [
              function(it){
                return it.forceY;
              }, forceY
            ]
          ]));
          g(this$.chart, view, seriesWithTrendline, options);
          return continuation(this$.chart, seriesWithTrendline, function(){
            var svg;
            svg = d3.select(view).select('svg');
            if (svg.empty()) {
              d3.select(view).append('div').attr('style', "position: absolute; left: 0px; top: 0px; width: 100%; height: 100%").append('svg').datum(seriesWithTrendline).call(this$.chart);
            } else {
              d3.select(view).select('svg').datum(seriesWithTrendline).call(this$.chart);
            }
            return this$.chart.update();
          });
        });
      })
    };
  };
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);
