(function(){
  var ref$, id, filter, Obj, objToPairs, sortBy;
  ref$ = require('prelude-ls'), id = ref$.id, filter = ref$.filter, Obj = ref$.Obj, objToPairs = ref$.objToPairs, sortBy = ref$.sortBy;
  module.exports = function(arg$){
    var Plottable, nv, plotChart, plot;
    Plottable = arg$.Plottable, nv = arg$.nv, plotChart = arg$.plotChart, plot = arg$.plot;
    return new Plottable(curry$(function(view, result, arg$, continuation){
      var cell, cells, colsOrder, cols, x$, y$, $table, z$, z1$, z2$;
      cell = arg$.cell, cells = arg$.cells, colsOrder = arg$.colsOrder, cols = arg$.cols;
      cols = cols != null
        ? cols
        : function(){
          return sortBy(function(it){
            var b;
            b = colsOrder.indexOf(it);
            if (b === -1) {
              return Infinity;
            } else {
              return b;
            }
          })(
          filter(compose$(function(it){
            return it.indexOf('$');
          }, (function(it){
            return it !== 0;
          })))(
          Obj.keys(
          result[0])));
        }();
      if (d3.select(view).select('pre').empty()) {
        x$ = d3.select(view).append('pre').append('table').attr('class', 'plottable');
        x$.append('thead').append('tr');
        x$.append('tbody');
      }
      y$ = $table = d3.select(view).select('table');
      z$ = y$.select('thead tr').selectAll('td').data(cols);
      z$.enter().append('td');
      z$.exit().remove();
      z$.text(id);
      z$.attr('class', id);
      z1$ = y$.select('tbody').selectAll('tr').data(result);
      z1$.enter().append('tr').attr('style', function(it){
        return it.$style;
      });
      z1$.exit().remove();
      z2$ = z1$.selectAll('td').data(compose$(objToPairs, filter(function(arg$){
        var k;
        k = arg$[0];
        return cols.indexOf(k) > -1;
      }), sortBy(function(arg$){
        var k;
        k = arg$[0];
        return cols.indexOf(k);
      })));
      z2$.enter().append('td');
      z2$.exit().remove();
      z2$.each(function(arg$){
        var key, value, f;
        key = arg$[0], value = arg$[1];
        f = cells[key];
        if (!!f) {
          return plot(f)(this, value);
        } else {
          return cell(this, key, value);
        }
      });
      continuation($table, result, function(){});
    }), {
      cell: curry$(function(view, key, value){
        return d3.select(view).text(value).attr('class', key);
      }),
      cells: {},
      colsOrder: [],
      cols: null
    });
  };
  function compose$() {
    var functions = arguments;
    return function() {
      var i, result;
      result = functions[0].apply(this, arguments);
      for (i = 1; i < functions.length; ++i) {
        result = functions[i](result);
      }
      return result;
    };
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);
