(function(){
  var ref$, Obj, Str, id, any, average, concatMap, drop, each, filter, find, foldr1, foldl, map, maximum, minimum, objToPairs, pairsToObj, sort, sum, tail, take, unique, d3, nv, d3Tip, fillIntervals, rextend, $, Plottable, plottable, plot, withOptions, more, project, json, csv, plotChart, plottables, x$, layoutPlottables, layoutHorizontal, layoutVertical, slice$ = [].slice;
  require('prelude-ls');
  ref$ = require('prelude-ls'), Obj = ref$.Obj, Str = ref$.Str, id = ref$.id, any = ref$.any, average = ref$.average, concatMap = ref$.concatMap, drop = ref$.drop, each = ref$.each, filter = ref$.filter, find = ref$.find, foldr1 = ref$.foldr1, foldl = ref$.foldl, map = ref$.map, maximum = ref$.maximum, minimum = ref$.minimum, objToPairs = ref$.objToPairs, pairsToObj = ref$.pairsToObj, sort = ref$.sort, sum = ref$.sum, tail = ref$.tail, take = ref$.take, unique = ref$.unique;
  d3 = window.d3 = require('d3');
  if (typeof global !== 'undefined') {
    global.d3 = d3;
  }
  nv = require('nvd3');
  d3Tip = require('d3-tip');
  d3Tip(d3);
  ref$ = require('./plottables/_utils'), fillIntervals = ref$.fillIntervals, rextend = ref$.rextend;
  $ = require('jquery-browserify');
  Plottable = (function(){
    Plottable.displayName = 'Plottable';
    var prototype = Plottable.prototype, constructor = Plottable;
    function Plottable(plotter, options, continuations, projection){
      this.plotter = plotter;
      this.options = options != null
        ? options
        : {};
      this.continuations = continuations != null
        ? continuations
        : function(){
          var callback;
          callback = arguments[arguments.length - 1];
          return callback(null);
        };
      this.projection = projection != null ? projection : id;
      this._plotter = bind$(this, '_plotter', prototype);
    }
    prototype._plotter = function(view, result, parameters){
      var options;
      options = (function(){
        switch (false) {
        case typeof this.options !== 'function':
          return this.options(parameters);
        default:
          return this.options;
        }
      }.call(this));
      return this.plotter(view, this.projection(result, options), options, this.continuations);
    };
    return Plottable;
  }());
  plottable = function(f){
    return new Plottable(curry$(function(view, result, options){
      f(view, result, options);
    }));
  };
  plot = curry$(function(p, view, result, parameters){
    return p._plotter(view, result, parameters);
  });
  withOptions = function(p, f){
    var newOptions;
    newOptions = (function(){
      switch (false) {
      case typeof f !== 'function':
        return function(parameters){
          var currentOptions;
          currentOptions = typeof p.options === 'function'
            ? p.options(parameters)
            : p.options;
          return rextend(rextend({}, currentOptions), f(parameters));
        };
      default:
        return rextend(rextend({}, p.options), f);
      }
    }());
    return new Plottable(p.plotter, newOptions, p.continuations, p.projection);
  };
  more = function(p, c){
    return new Plottable(p.plotter, rextend({}, p.options), function(){
      var i$, init, callback, ex;
      init = 0 < (i$ = arguments.length - 1) ? slice$.call(arguments, 0, i$) : (i$ = 0, []), callback = arguments[i$];
      try {
        c.apply(null, init);
      } catch (e$) {
        ex = e$;
        return callback(ex);
      }
      return callback(null);
    }, p.projection);
  };
  project = curry$(function(f, p){
    return new Plottable(p.plotter, rextend({}, p.options), p.continuations, function(result, options){
      return p.projection(f(result, options), options);
    });
  });
  json = function(view, result){
    return view.innerHTML = "<pre>" + JSON.stringify(result, null, 4) + "</pre>";
  };
  csv = function(view, result){
    var columns, x$, pre;
    columns = keys(result[0]);
    columns.join(',') + "\n" + function(){
      return Str.join("\n")(
      foldl(function(acc, row){
        acc.push(Str.join(',')(
        map(function(column){
          return row[column];
        })(
        columns)));
        return acc;
      }, [])(
      result));
    }();
    x$ = pre = $("<pre/>");
    x$.text(jsonToCsv(result));
    return $(view).append(pre);
  };
  plotChart = function(view, result, chart){
    d3.select(view).append('div').attr('style', "position: absolute; left: 0px; top: 0px; width: 100%; height: 100%").append('svg').datum(result).call(chart);
  };
  plottables = {
    pjson: new Plottable(curry$(function(view, result, arg$, continuation){
      var pretty, space, x$, pre;
      pretty = arg$.pretty, space = arg$.space;
      x$ = pre = $("<pre/>");
      x$.html(!pretty
        ? JSON.stringify(result)
        : JSON.stringify(result, null, space));
      $(view).append(pre);
    }), {
      pretty: true,
      space: 4
    }),
    table: require('./plottables/table')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    histogram1: require('./plottables/histogram1')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    histogram: require('./plottables/histogram')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    stackedArea: require('./plottables/stacked-area')({
      Plottable: Plottable,
      nv: nv,
      d3: d3,
      plotChart: plotChart,
      plot: plot
    }),
    scatter1: require('./plottables/scatter1')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    scatter: require('./plottables/scatter')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    correlationMatrix: require('./plottables/correlation-matrix')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    regression: require('./plottables/regression')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    timeseries1: require('./plottables/timeseries1')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    timeseries: require('./plottables/timeseries')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    multiBarHorizontal: require('./plottables/multi-bar-horizontal')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    heatmap: require('./plottables/heatmap')({
      Plottable: Plottable,
      d3: d3,
      plot: plot
    }),
    multiChart: require('./plottables/multi-chart')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    funnel: require('./plottables/funnel')({
      Plottable: Plottable,
      d3: d3,
      nv: nv,
      plotChart: plotChart,
      plot: plot
    }),
    funnel1: require('./plottables/funnel1')({
      Plottable: Plottable,
      d3: d3
    })
  };
  x$ = (ref$ = layoutPlottables = require('./plottables/layout')({
    Plottable: Plottable,
    d3: d3,
    nv: nv,
    plotChart: plotChart,
    plot: plot
  }), layoutHorizontal = ref$.layoutHorizontal, layoutVertical = ref$.layoutVertical, ref$);
  x$.layoutHorizontal = function(){
    return withOptions(layoutHorizontal.apply(this, arguments), id);
  };
  x$.layoutVertical = function(){
    return withOptions(layoutVertical.apply(this, arguments), id);
  };
  module.exports = function(){
    var ref$;
    return import$((ref$ = import$(import$({}, plottables), layoutPlottables), ref$.Plottable = Plottable, ref$.plot = plot, ref$.plottable = plottable, ref$.withOptions = withOptions, ref$.more = more, ref$.project = project, ref$.json = json, ref$.csv = csv, ref$.fillIntervals = fillIntervals, ref$.React = require('react'), ref$.ReactDOM = require('react-dom'), ref$), require('prelude-ls'));
  };
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
